#ifndef SNOOP_H
#define SNOOP_H

typedef struct {
  int i;
  int j;
  int u;
  char *structure;
  float energy;
  float Duplex_El;
  float Duplex_Er;
  float Loop_E;
  float Loop_D;
  float pscd;
  float psct;
  float pscg;
  float Duplex_Ol;
  float Duplex_Or;
  float Duplex_Ot;
} snoopT;

extern snoopT snoopfold(const char *s1, const char *s2, 
			const int penalty, const int threshloop, 
			const int threshLE, const int threshRE, const int threshDE, const int threshD,
			const int half_stem, const int max_half_stem,
			const int min_s2, const int max_s2, const int min_s1, const int max_s1, const int min_d1, const int min_d2);

extern snoopT *snoop_subopt(const char *s1, const char *s2, int delta, int w, 
			    const int penalty, const int threshloop, 
			    const int threshLE, const int threshRE, const int threshDE, const int threshTE,const int threshSE,
			    const int threshD,
			    const int distance,
			    const int half_stem, const int max_half_stem,
			    const int min_s2, const int max_s2, const int min_s1, const int max_s1, const int min_d1, const int min_d2);

extern void Lsnoop_subopt(const char *s1, const char *s2, int delta, int w, 
			  const int penalty, const int threshloop, 
			  const int threshLE, const int threshRE, const int threshDE, const int threshTE,const int threshSE,
			  const int threshD,
			  const int distance,
			  const int half_stem, const int max_half_stem,
			  const int min_s2, const int max_s2, const int min_s1, const int max_s1, const int min_d1, const int min_d2, const int alignment_length, const char* name);

extern void Lsnoop_subopt_list (const char *s1, const char *s2, int delta, int w, 
				const int penalty, const int threshloop, 
				const int threshLE, const int threshRE, const int threshDE, const int threshTE,const int threshSE,
				const int threshD,
				const int distance,
				const int half_stem, const int max_half_stem,
				const int min_s2, const int max_s2, const int min_s1, const int max_s1, const int min_d1, const int min_d2, const int alignment_length, const char *name);

extern void Lsnoop_subopt_list_XS (const char *s1, const char *s2, const int **access_s1, int delta, int w, 
				   const int penalty, const int threshloop, 
				   const int threshLE, const int threshRE, const int threshDE, const int threshTE,const int threshSE,
				   const int threshD,
				   const int distance,
				   const int half_stem, const int max_half_stem,
				   const int min_s2, const int max_s2, const int min_s1, const int max_s1, const int min_d1, const int min_d2, const int alignment_length, const char *name);

extern void snoop_subopt_XS (const char *s1, const char *s2, const int **access_s1, int delta, int w, 
				   const int penalty, const int threshloop, 
				   const int threshLE, const int threshRE, const int threshDE, const int threshTE,const int threshSE,
				   const int threshD,
				   const int distance,
				   const int half_stem, const int max_half_stem,
				   const int min_s2, const int max_s2, const int min_s1, const int max_s1, const int min_d1, const int min_d2, const int alignment_length, const char *name);

extern snoopT *alisnoop_subopt(const char **s1, const char **s2, int delta, int w, 
			       const int penalty, const int threshloop, 
			       const int threshLE, const int threshRE, const int threshDE, const int threshTE,const int threshSE,
			       const int threshD,
			       const int distance,
			       const int half_stem, const int max_half_stem,
			       const int min_s2, const int max_s2, const int min_s1, const int max_s1, const int min_d1, const int min_d2);

extern snoopT *aliLsnoop_subopt_list (const char **s1, const char **s2, int delta, int w, 
				      const int penalty, const int threshloop, 
				      const int threshLE, const int threshRE, const int threshDE, const int threshTE,const int threshSE,
				      const int threshD,
				      const int distance,
				      const int half_stem, const int max_half_stem,
				      const int min_s2, const int max_s2, const int min_s1, const int max_s1, const int min_d1, const int min_d2, const int alignment_length);

extern snoopT alisnoopfold(const char **s1, const char **s2, 
			   const int penalty, const int threshloop, const int threshLE, const int threshRE, const int threshDE, const int threshD,
			   const int half_stem, const int max_half_stem,
			   const int min_s2, const int max_s2, const int min_s1, const int max_s1, const int min_d1, const int min_d2);


extern snoopT snoopfold_XS(const char *s1, const char *s2, const int **access_s1, const  int pos, const int max_pos_j,
			const int penalty, const int threshloop, 
			const int threshLE, const int threshRE, const int threshDE, const int threshD,
			const int half_stem, const int max_half_stem,
			const int min_s2, const int max_s2, const int min_s1, const int max_s1, const int min_d1, const int min_d2);




extern int snoop_subopt_sorted;
#endif
